/*
 * Copyright (c) 2004, 2005 The University of Utah
 *
 * This file is part of Jiazzi.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions, and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* atom-edu.utah.jiggy.bytecode outattr.SourceFile */

package edu.utah.jiggy.bytecode.bt;

import java.io.*;

import edu.utah.jiggy.clazz.ClassModel;
import edu.utah.jiggy.meta.shape.Base;

public class BTUnknown extends BTAttr {
    protected byte b[];
    final String name;

    public String name() {
        return this.name;
    }

    protected int size(ClassModel clazz, Base base) {
        return this.b.length;
    }

    protected BTAttr read(int size, DataInputStream in, ClassModel clazz,
                          BTBase base, Base bld) throws IOException {
        BTUnknown attr = (BTUnknown) super.read(size, in, clazz, base, bld);
        attr.b = new byte[size];
        in.readFully(attr.b);
        return attr;
    }

    public ByteArrayInputStream bytes() {
        return new ByteArrayInputStream(this.b);
    }

    protected boolean prepareWrite(ClassModel clazz, Base base) {
        return false;
    }

    protected void write(DataOutputStream out, ClassModel clazz, Base base)
            throws IOException {
        if (true)
            throw new Error();
        super.write(out, clazz, base);
        out.write(this.b);
    }

    public BTUnknown(String name) {
        super();
        this.name = name;
    }
}
